#!py

'''
01.07.05  def buildPackage()
15.07.05  def getProofenv()
25.07.05  def checkRootfiles() , def updateProofhistory()
27.07.05  remote functions
29.07.05  CFile creating in CPS, remote functions, data exchange between CPS and CRPS
11.08.05  changed :  facility:host//file
15.09.05  changed : extended cleanup functionallity in the case of an user/system interrupt
12.10.05  paths are now stored in variables / softlinks  

19.12.05  setSlaveDistribution  ----   in progress

20.01.06  support for XROOTD and system daemons --- in progress  
	- replaced TNetFile with TXNetFile
'''

# delete # in:
#to change: 
#L436  insert ROOT install path  L444 insert current ROOT version

import getopt,sys,os,math,string,commands,exceptions,time,popen2,socket,signal,thread

#Importing modules and classes depending on the parameter given by the user
#if para[1] == 1:
#	import socket
#this can only happen AFTER the parameters has been processed

REMOTE=0
PROOFPATH=""
GRIDMAPPATH=""
CERTIFICATEPATH=""

port=1099   #delete this ASAP

class CJob:
	def __init__(self,slaves,user,masterslave,mol,proofenv,rootversion,rootvnum,home):
		self.path=""
		self.slaves=slaves
		self.countrunning=0
		self.countall=0
		self.submissions=0
		self.user=user
		self.home=home
		self.rootversion=rootversion
		self.rootvnum=rootvnum
		self.masterslave=masterslave
		self.mol=mol
		self.localcapabilitys=0
		self.lsfcapabilitys=0
		self.pbscapabilitys=0
		self.localsubmissions=0
		self.pbssubmissions=0
		self.lsfsubmissions=0
		self.slaveslocal=0
		self.slaveslsf=0
		self.slavespbs=0
		
		self.proofenv=proofenv

	def work(self):
		#this is done from the CPS before, no need for a second check
		#self.getCapabilitys()
		
		if self.mol==1:
			self.jobStart()
		if REMOTE == 0:  #only the CPS should calculate this
			self.setSlaveDistribution()
		self.jobStarting()
		print "CJob work"
		
		#must return the amount of jobsubmissions
		return self.submissions
		#return (self.lsfsubmissions+self.pbssubmissions+self.localjobs)
	
	def getPath(self):
		pass
	
	def getCapabilitys(self):
		#get the capabilitys by using proofenv
		print "capability check"
		if self.proofenv[0][2].find("local") != -1:
			#check if file is there
			if commands.getstatusoutput("df "+PROOFPATH+"/.proof_local.conf")[0] != 0:
				print "Got entry for local capabilitys in proof_env.conf but no .proof_local.conf was found! Without this file local PROOF is not available!"
			else :
				self.localcapabilitys = 1
		if self.proofenv[0][2].find("LSF") != -1:
			if commands.getstatusoutput("/usr/bin/which bsub")[0] == 0:
				self.lsfpath=commands.getoutput("/usr/bin/which bsub")
				self.lsfpath=self.lsfpath.rstrip("/bsub")
				self.lsfcapabilitys = 1
		elif self.proofenv[0][2].find("PBS") != -1:
			print commands.getstatusoutput("which qsub")
			if commands.getstatusoutput("/usr/bin/which qsub")[0] == 0:
				self.pbspath=commands.getoutput("/usr/bin/which qsub")#raises exception OR if getpath returns an empty string
				self.pbspath=self.pbspath.rstrip("/qsub")
				self.pbscapabilitys = 1
			#self.pbspath=("/usr/pbs/bin")
			self.pbscapabilitys = 1

		if self.localcapabilitys == 0 and self.lsfcapabilitys == 0 and self.pbscapabilitys == 0:
			print "Sorry, but it seems that you can't use PROOF because of there are no available local, batch or GRID resources!\nPossibly you have to login to another host."
			sys.exit(1)

		print "local capabiliys found : ",
		print self.localcapabilitys
		print "LSF capabiliys found : ",
		print self.lsfcapabilitys
		print "PBS capabiliys found : ",
		print self.pbscapabilitys
			
	def setSlaveDistribution(self):	#calculate the spread of the slaveservers in an distributed session
		
		self.slaveslsf=self.slaves
		
		#calculate the distribution of the slaves
		#self.


		#local jobs and GSI-LSF jobs have an restricted amount
		#self.slaveslsf=self.slaves
		
		#to test the mixed (local  and batch) environment  OK
		#self.slaveslsf=(self.slaves*2)/3
		#self.slaveslocal=self.slaves-self.slaveslsf
		
		#new trial :
		'''
		batch_jobs=self.slaves*priority
		get_max_jobs_local() : get_free_local_hosts() / factor
		self.slaveslocal=(slaves-batch_jobs)*factor
		if self.slaveslocal > max_jobs_local :
			self.slaveslocal=max_jobs_local
			#reasign the amount of batch jobs
			batch_jobs+=self.slaves-(self.slaveslocal/factor)  #but what if we don't have enough jobslots on the farm?
				
		'''
		
		#newer trial :
		'''
		get_max_jobs_local()
		get_max_jobs_batch()
		for each in grid_list :
			get_max_jobs_grid()
		calculate the job distribution depending on the data distribution and the distribution of the data server
		divide all_jobs into jobs_per_institut
		calculate the local job distribution depending on the amount of jobslots, free local hosts, the factor and the priority
		divide local_institut_jobs into local_jobs and batch_jobs
		
		
		
		'''
		
		print "slaves in the local area : ",
		print self.slaveslocal
		print "slaves via LSF : ",
		print self.slaveslsf
		print "slaves via PBS : ",
		print self.slavespbs
	
	def jobStarting(self):
		print "start jobs"
		if self.localcapabilitys==1:
			self.joblocal=CJobLocal(self.slaveslocal,self.user,self.masterslave,self.rootversion,self.rootvnum,self.submissions,self.home)
			self.submissions,self.masterslave=self.joblocal.work()
			#self.submissions+=self.localsubmissions
			#print self.localjobs
			print self.submissions
		if self.lsfcapabilitys==1:
			self.joblsf=CJobLsf(self.slaveslsf,self.user,self.masterslave,self.lsfpath,self.rootversion,self.rootvnum,self.submissions,self.home)
			self.submissions,self.masterslave=self.joblsf.work()
			print self.submissions
			#self.submissions+=self.lsfsubmissions
		elif self.pbscapabilitys==1:
			self.jobpbs=CJobPbs(self.slavespbs,self.user,self.masterslave,self.pbspath,self.rootversion,self.rootvnum,self.submissions,self.home)
			self.submissions,self.masterslave=self.jobpbs.work()
			#self.submissions+=self.pbssubmissions

	def jobStart(self):	#starts local job for mol
		print "mol active"
		os.environ["master_slave"]=self.masterslave
		os.environ["versuchscounter"]=str(self.submissions)
		os.spawnl(os.P_NOWAIT,PROOFPATH+"/proofd_local.sh")
		self.submissions+=1
		self.masterslave="slave"
		
	def jobKill(self):
		if self.mol == 1:
			os.spawnl(os.P_NOWAIT,"pkill proofd")
			#os.spawnl(os.P_NOWAIT,"pkill rootd")#this is done via script
		if self.lsfcapabilitys == 1:
			self.joblsf.jobKill()
		if self.pbscapabilitys == 1:
			self.jobpbs.jobKill()
		if self.localcapabilitys == 1:
			self.joblocal.jobKill()	
	
	
class CJobLocal:		
	def __init__(self,slaves,user,masterslave,rootversion,rootvnum,submissions,home):
		self.path=""
		self.rootversion=rootversion
		self.rootvnum=rootvnum
		self.slaves=slaves
		self.countrunning=0
		self.countall=0
		self.submissions=submissions
		self.user=user
		self.home=home
		self.masterslave=masterslave
		self.localhosts=[]
		self.usedhosts=[]

	def work(self):
		self.getHosts()
		self.jobMonitoring()
		print "CJobLocal  work"
		return self.submissions,self.masterslave
	
	def getHosts(self):
		try:
			f=open(PROOFPATH+"/.proof_local.conf") 
			for each in f.readlines():
				self.localhosts.append(each)
			f.close()
		except:
			print "No .proof_local.conf file found! Without this file, local capabilitys are not available!"
			return 0
	
	def jobMonitoring(self):
		for each in self.localhosts:  
			if self.countrunning < self.slaves:
				print "searching for free local hosts"
				each=each.rstrip("\n")
				if commands.getstatusoutput("ssh -i "+self.home+"/.ssh/PROOF "+each+" pgrep proofd")[0] == 256:    #returns (256,'') if none proofd is running, else (0,'PID')
					self.jobSubmission(each)
					#if job runs, add it to the list 
					print "new job submitted per ssh"
					self.usedhosts.append(each)
					#stringb=commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each+" pgrep proofd")
					self.countrunning+=1
			else:
				break
		
	def jobSubmission(self,host):
		self.submissions+=1
		os.environ["master_slave"]=self.masterslave
		os.environ["versuchscounter"]=str(self.submissions)
		#print commands.getstatusoutput("ssh -i "+self.home+"/.ssh/PROOF "+host+" "+PROOFPATH+"/proofd_local.sh "+self.rootversion+" "+self.masterslave+" "+str(self.submissions)+" "+str(self.rootvnum))
		#it seems that the key is not needed to be given, it only makes additional problems
		print commands.getstatusoutput("ssh "+host+" "+PROOFPATH+"/proofd_local.sh "+self.rootversion+" "+self.masterslave+" "+str(self.submissions)+" "+str(self.rootvnum))
		#this is not working, because there are some more things to be done
		#commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each+" \"/etc/profile;"+self.home+"/.profile;export GSI_COMPILER_CC="gcc295-04";export GSI_OS_FLAVOR="debian";export GSI_OS_VERSION="3.0";. rootlogin "+self.rootversion+";proofd -p 1095; rootd -p 1099\"")
		print "local Job started"
		self.masterslave="slave"	
			
	def jobKill(self):
		for each in self.usedhosts:
			#commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each+" pkill proofd")  #kill the proofd, so the script can continue to work, kill the rootd (if any) and so on
			commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each+" \"pkill proofd;pkill rootd;rm -r -f /tmp/proof;rm -r -f /tmp/packages\"")  #kill the proofd, so the script can continue to work, kill the rootd (if any) and so on

					
class CJobLsf:		
	def __init__(self,slaves,user,masterslave,path,rootversion,rootvnum,submissions,home):
		self.path=path
		self.rootversion=rootversion
		self.rootvnum=rootvnum
		self.submissions=submissions
		self.slaves=slaves
		self.countrunning=0
		self.countall=0
		self.user=user
		self.home=home
		self.masterslave=masterslave
		self.lsfsubmissions=0

	def work(self):
		self.jobMonitoring()
		print "CJobLsf  work"
		#must return the amount of jobsubmissions
		return self.submissions,self.masterslave
	
	def jobMonitoring(self):
		while self.countrunning < self.slaves:
			stringa=commands.getoutput("bjobs -u "+self.user+" -J proofd -q proof -r | grep RUN | wc -l").split("\n")
			self.countrunning=int(stringa[len(stringa)-1])
			print "running jobs : ",
			print self.countrunning
			stringb=commands.getoutput("bjobs -u "+self.user+" -J proofd -q proof -r -p | grep proofd | wc -l").split("\n")
			self.countall=int(stringb[len(stringb)-1])
			print "all jobs : ",
			print self.countall
			while self.countall < self.slaves:
				self.jobSubmission()
				stringb=commands.getoutput("bjobs -u "+self.user+" -J proofd -q proof -r -p | grep proofd | wc -l").split("\n")
				self.countall=int(stringb[len(stringb)-1])
				print "all jobs : ",
				print self.countall
			time.sleep(10)
		
	def jobSubmission(self):
		print "LSF job submission : ",
		print self.submissions
		self.submissions+=1
		os.environ["master_slave"]=self.masterslave
		os.environ["versuchscounter"]=str(self.submissions)

		commands.getoutput("bsub -q proof -J proofd "+PROOFPATH+"/proofd.sh")
		print "Job submitted"
		self.masterslave="slave"
			
	def jobKill(self):
		commands.getoutput("bkill -J proofd -u $(whoami) -q proof") 


class CJobPbs:		
	def __init__(self,slaves,user,masterslave,path,rootversion,rootvnum,submissions,home):
		self.path=path
		self.slaves=slaves
		self.rootversion=rootversion
		self.rootvnum=rootvnum
		self.submissions=submissions
		self.countrunning=0
		self.countall=0
		self.user=user
		self.home=home
		self.masterslave=masterslave
		
	def work(self):
		print self.user
		self.jobMonitoring()
		print "CJobPbs  work"
		#must return the amount of jobsubmissions
		return self.submissions,self.masterslave
	
	def jobSubmission(self):
		self.submissions+=1
		os.environ["master_slave"]=self.masterslave
		os.environ["versuchscounter"]=str(self.submissions)
		print commands.getoutput(self.path+"/qsub -N proofd -q long "+PROOFPATH+"/proofd.sh -v "+self.rootversion+" "+self.master_slave+" "+self.versuchscounter+" "+self.rootvnum)
		print "new job submitted"
		#print commands.getoutput("qsub /grid/fzk.de/home/proof/proof_temp/proofd.sh")
	
	def jobMonitoring(self):  
		print "in monitoring"
		print commands.getoutput(self.path+"/qselect -u "+self.user+" -N proofd | wc -l")
		print self.slaves
		while int(commands.getoutput(self.path+"/qselect -u "+self.user+" -N proofd -s R | wc -l")) < self.slaves:
			print "in moni2"
			while int(commands.getoutput(self.path+"/qselect -u "+ self.user+" -N proofd | wc -l")) < self.slaves:
				print "in moni3"
				print commands.getoutput(self.path+"/qselect -u "+self.user+" -N proofd | wc -l")
				self.jobSubmission()
			time.sleep(10)
				
	def jobKill(self):
		commands.getoutput("qdel -J proofd -u $whoami")
		# OR
		#commands.getoutput("qsig -SIGINT -J proofd -u $whoami")
		#this depends on the architecture of the proofd script. 
		#Use qdel if the proofds running in the foreground and qsig if they are running in the background
		#1. qdel kills the job and the proofd if it is running in the foreground 
		#2. qsig creates a trap that kills the proofd and remove files, etc.
	

class CFile:
	def __init__(self,filename,treename,loc,location):
		self.filename=filename
		self.treename=treename
		self.loc=loc		#nothing(for local),GSI,FZK
		self.location=location 	#servername
		self.rootd=0
		self.totalBytes=0
		self.zippedBytes=0
		self.compressionFactor=1.0
		self.filecount=0

	def output(self):
		print "*****************************"
		print self.filename
		print self.treename
		print self.loc		#nothing(for local),GSI,FZK
		print self.location 	#servername
		print self.rootd
		print self.totalBytes
		print self.zippedBytes
		print self.compressionFactor
		print "*****************************"

	
class CRootSession:

	def __init__(self,home,package,filelist,treename,rootversion,analysis,liblist):
		self.home=home
		self.package=package
		self.filelist=filelist
		self.treename=treename
		self.rootversion=rootversion
		self.proofline=""
		self.analysis=analysis
		self.liblist=liblist
	
	def work(self):
		self.buildProofstarterline()
		self.buildProofstarterc()
		self.startRoot()
	
	def rootlogin(self): #put this stuff to def getRootversion(): #even this is not needed if the rootvnum is given by the proof script
		return commands.getoutput("root-config --version | sed -e 's/\.//g' | sed -e 's/\///g'"),os.environ['ROOTSYS']
		
	def buildProofstarterc(self):
		f=open(self.home+"/proof_temp/proofstarter.C",'w')
		f.write("{\ngSystem->Load(\"libTreePlayer\");\n")  #for 502-00 only 
		f.write("gROOT->Proof(\""+self.proofline+"\");\n")
		#f.write("{\ngROOT->Proof(\""+self.proofline+"\");\n")
		if self.package != "":
			for each in self.liblist:
				f.write( "gSystem->Load(\""+each+"\");\n")
			f.write("gProof->UploadPackage(\""+self.home+"/proof_temp/"+self.package+"\");\n")
			f.write("gProof->EnablePackage(\""+self.package+"\");\n")
		if len(self.filelist) > 0 and self.treename != "":	# None or "" doesn't make a difference, both methods are not working
			f.write("TDSet *set;\n")
			f.write("set=new TDSet(\"TTree\",\""+self.treename+"\");\n")
			for files in self.filelist:
				facility=""
				host=""
				file=""
				line=files.split(':')
				if len(line) > 1:  #facility name was given
					facility=line[0]
					print "facility"
					lines=line[1].split("//")
					if len(lines) > 1:	#hostname was given
						print "host"
						host=lines[0]
						file="/"+lines[1]
					else :
						file=lines[0]
						print "file"
				else :
					lines=line[0].split("//")
					if len(lines) > 1:	#hostname was given
						host=lines[0]
						file="/"+lines[1]
						print "host 2"
					else :
						file=lines[0]
						print lines
						print file
						print "file 2"
				if host == "":
					f.write("set->Add(\""+file+"\");\n")
				else :
					f.write("set->Add(\"root://"+host+":"+port+"/"+file+"\");\n")
			if self.analysis != "":
				f.write("set->Process(\""+self.analysis+"\");\n");
		f.write("}")
		f.close()
				
	def buildProofstarterline(self):
		f=open(self.home+"/.proof.conf",'r')
		self.linea=f.readline()
		self.linea=self.linea.split()
		self.lineb=self.linea[2].lstrip("port=")
		self.proofline=self.linea[1]+":"+self.lineb
		print self.proofline
	
	def startRoot(self):
		print "starting ROOT ..."
		os.system("root -l \"$HOME/proof_temp/proofstarter.C\"")		#OK
		
	def checkRootfiles(self,filelist,user,frontendhost):
		print "checking ROOT files"
		print filelist
		#copy and use the parameter
		self.user=user
		self.frontendhost=frontendhost
		self.CF=[]
		#start a rootd on the frontend host of the current facility
		#os.system("ssh -i "+self.home+"/.ssh/PROOF "+frontendhost+" "+self.home+"/proof_temp/rootd.sh") #add the current root version
		#self.rootlogin()
		#split filelist entrys into location, hostname and filename   #GSI:lxg0503.gsi.de//tmp/hitfile.root
		for files in filelist:
			facility=""
			host=""
			file=""
			line=files.split(':')
			if len(line) > 1:  #facility name was given
				facility=line[0]
				print "facility"
				lines=line[1].split("//")
				if len(lines) > 1:	#hostname was given
					print "host"
					host=lines[0]
					file="/"+lines[1]
				else :
					file=lines[0]
					print "file"
			else :
				lines=line[0].split("//")
				if len(lines) > 1:	#hostname was given
					host=lines[0]
					file="/"+lines[1]
					print "host 2"
				else :
					file=lines[0]
					print lines
					print file
					print "file 2"
			
			print "new file created"
			print facility
			print host
			print file
			self.CF.append(CFile(file,self.treename,facility,host))
			
			print "new file added"
		print "checking files"
		#check if files exists and get the fileserver
		lines=""
		for each in self.CF:
			print each
			print each.filename
			#if os.path.exists (each.filename) != 0 :
			if commands.getstatusoutput("df "+each.filename)[0] != 0:
				print "NFS check failed"
				print each.location+"   "+each.filename
				if commands.getstatusoutput("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" /bin/df "+each.filename)[0] == 0:  #check if it's a file on a local disk
					lines=commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" /bin/df "+each.filename)
					print "LINES : "
					print lines
					os.system("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" "+PROOFPATH+"/rootd.sh")
					each.rootd=1
					print "remote file check OK"
				else:
					print "File "+each.filename+" not found!"
					sys.exit(1)
			else:
				print "NFS check OK"
				print socket.getfqdn(each.location)
				if each.location != "" and socket.getfqdn(each.location) != socket.getfqdn():
					lines=commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" /bin/df "+each.filename)
					os.system("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" "+PROOFPATH+"/rootd.sh")
					each.rootd=1
					print "remote file check OK"			
				else:
					print "NFS filecheck OK"
					lines=commands.getoutput("df "+each.filename)
			
			host=""
			lines=commands.getoutput("df $HOME")
			print lines
			lines=lines.split()
			line=lines[7]		#returns f.e.  /net/home1/rz/dvlambda
			print line
			if line.find(':/') != -1:
				host=line.split(':/')[0]
				blocks=host
			else :
				line=line.split('/')
				print line
				location=line[2]  #returns f.e. home1
				print location
				filepath=""
				text=commands.getoutput("df")
				texte=text.split()
				for block in texte:
					if block.find(location) != -1:
						filepath=block
						print "found location"
						print filepath
						break
					blocks=filepath.split(':/')
					host=filepath.split(':/')[0]

			print "servername:"+host
			
			'''			
			print lines
			lines=lines.split()
			line=lines[7]		#returns f.e.  /net/home1/rz/dvlambda
			print line
			line=line.split('/')
			print line
			
			location=line[2]  #returns f.e. home1
			#location=line[0]  #on lxi002 and alice this returns the fileserver directly
			
			print location
			filepath=""
			text=commands.getoutput("df")
			texte=text.split()
			for block in texte:
				if block.find(location) != -1:
					filepath=block
					print "found location"
					print filepath
					break
			blocks=filepath.split(':/')
			print "block"
			print blocks[0]
			'''
			
		#create trap with a timeout to wait for ROOT
		#if ROOT does not return, kill it by system or exit the PROOF session
		'''
		a=1

		def handler(signum, frame):
			print "It seems, that the ROOT session for the filechecking hangs. Got to terminate this."
			os.system("pkill root")
			sys.exit(0)

		# Set the signal handler and a 60-second alarm
		signal.signal(signal.SIGALRM, handler)
		signal.alarm(60) #terminate the process after 60 seconds

		#ROOT

		#this come after the process that we are waiting for		
		signal.alarm(0)          # Disable the alarm
	
		print "test"
		'''	
		
		stringa="a"
		stringb="b"
		print "before ROOT started for file checking"
		pipe=popen2.popen3("root -l -b",1,"w")
		pipe[1].write("int totalBytes;\n")
		pipe[1].write("int zippedBytes;\n")
		for each in self.CF:
			if each.rootd == 0:  
				pipe[1].write("TFile "+stringa+"=TFile(\""+each.filename+"\");\n") #file via rootd OR NFS
				print "TFile "+stringa+"=TFile(\""+each.filename+"\")" #file via rootd OR NFS
			else:
				commands.getoutput("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" "+PROOFPATH+"/rootd.sh")
				pipe[1].write("TXNetFile "+stringa+"=TXNetFile(\""+each.location+":"+port+"/"+each.filename+"\");\n") #file ONLY via rootd
				print "TXNetFile "+stringa+"=TXNetFile(\""+each.location+":"+port+"/"+each.filename+"\")"
			pipe[1].write("TTree *"+stringb+"="+stringa+"->Get(\""+each.treename+"\");\n")
			pipe[1].write("totalBytes="+stringb+"->GetTotBytes();\n")
			pipe[1].write("zippedBytes="+stringb+"->GetZipBytes();\n")
			pipe[1].write("cout<<totalBytes<<\"  \";\n")
			pipe[1].write("cout<<zippedBytes<<endl;\n")
			stringa=stringa+"a"
			stringb=stringb+"b"
		pipe[1].write(".q\n")
		
		print "reading error pipe"
		#check for errors
#		if pipe[2].read() != "":
#			print pipe[2].read()
#			print "Error during filecheck! Possibly one of your Root files is corrupted!"
#			#sys.exit(1)
		print "after reading error pipe"
#############################################
#		os.close(sys.stderr.fileno())
#############################################
		i=0
		text=pipe[0].readlines()
		print text
		for each in text:
			if each != "\n" and each.find(" ") != -1 and each != None:
				try:
					words=each.split()
					if len(words) == 2:
						self.CF[i].totalBytes=int(words[0])
						print self.CF[i].totalBytes
						self.CF[i].zippedBytes=int(words[1].rstrip("\n"))
						print self.CF[i].zippedBytes
						self.CF[i].compressionFactor=float(self.CF[i].totalBytes) / float(self.CF[i].zippedBytes)
						print self.CF[i].compressionFactor
						i+=1
					else:
						print "Error! 1"  #this message can appears often depending on the ROOT messages
				except:
					print "Error! 2"  #this message can appears often depending on the ROOT messages
		return self.CF
		#kill the rootd's, should be done in cleanup()
#		for each in self.CF:
#			if each.rootd == 1:
#				os.system("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" pkill -U "+self.user+" rootd")
#		os.system("ssh -i "+self.home+"/.ssh/PROOF "+frontendhost+" pkill -U "+self.user+" rootd")
		
		
#it's usefull to lock in GlobusAuthentication.cxx how to check the globus stuff
class CAuthentication:

	def __init__(self,authmethod,user,home):
		self.authmethod=authmethod
		self.user=user
		self.home=home

	def work(self):
		#if self.authmethod == 1 or local jobs (rootd or proofd) are started:
		self.createSSHKey()		

		if self.authmethod == 3:
			#self.UID=commands.getoutput("echo $UID")
			self.UID=os.getuid()
			self.checkForglobussupport()
			self.checkGridproxy()
			#self.checkCertificates()
			self.checkGridmapfile()
			self.buildHostcertconf()
			self.copyGridproxyfile()
			
	def createSSHKey(self):
		try :
			os.system("rm -f "+self.home+"/.ssh/PROOF.pub")
			os.system("rm -f "+self.home+"/.ssh/PROOF")
		except:
			pass

		commands.getstatusoutput("ssh-keygen -d -f "+self.home+"/.ssh/PROOF -N \"\"")
		
		f=open(self.home+"/.ssh/PROOF.pub")
		line=f.readline()
		f.close()
		ff=open(self.home+"/.ssh/authorized_keys",'a')
		ff.writelines(line)
		ff.close()
		
	def checkForglobussupport(self):  #this function is superseeded by root-config --has-globus in proof(.sh), so the first part (the globus check) can be skipped
		#var=os.environ["ROOTSYS"]
		#globus_support=0
		#f=open(var+"/configure")
		#for lines in f.readlines():
		#	if lines.find("--with-globus") != -1 and lines.find("enable_globus=\"yes\"") != -1:
		#		globus_support=1
		#		break

		if globus_support==0:
			print "This ROOT version does not support GLOBUS authentication!"
			print "Please choose another authentication method or an other ROOT version!"
			sys.exit(1)
			
	def buildHostcertconf(self):
		#mv hostcert.conf hostcert.conf.usr
		f=open(os.environ["HOME"]+"/.globus/hostcert.conf",'w')
		f.write("/usr/local/globus2.0/share/certificates *  * /usr/local/globus2.0/etc/grid-mapfile")
		f.close()
		
	#for this there is a function grid-proxy-info -e , but it's not working, only if using globus 2.4
	def checkGridproxy(self):
		line=commands.getoutput("grid-proxy-info -timeleft")
		if line.find("unable to determine proxy file name") != -1 or int(line) <= 3600:
			print "No valid grid-proxy found! Please create a one."
			os.system("grid-proxy-init")
			
	def copyGridproxyfile(self):
		if commands.getstatusoutput("/bin/cp /tmp/x509up_u"+self.UID+" "+os.environ["HOME"]+"/x509up_u"+self.UID)[0] != 0:
			print "Sorry, could not copy your grid-proxy file from /tmp to your home directory."
			exit(1)
	
	def checkCertificates(self): #the time values returned by the time functions are not defined the same on the different OS
		#get path from hostcert.conf?  or write path in hostcert.conf
		#check date of certs
		#time.strftime("%d-%m-%Y %H:%M")
		#time.time()
		statinfo=os.stat("/usr/local/globus2.0/share/certificates/fzk-crl-get.sh")
		# st_atime (time of most recent access), st_mtime (time of most recent content modification)
		if (time.time() - statinfo.st_atime ) > (3600 * 24 * 30):
			print time.time()
			print statinfo.st_atime
			print "Outdated certificates found! Please update your certificates!"
			sys.exit(1)
	
	def checkGridmapfile(self):
		found=0
		try:		
			f=open("/usr/local/globus2.0/etc/grid-mapfile")
			for line in f.readlines():
				if line.find(self.user) != -1:
					found=1
					break
			f.close()
		except:
			"grid-mapfile not found"
		if found==0:
			print "Your name was not found in the grid-mapfile! Please contact your admin!"
			sys.exit(1)
				

class CProofSession:
	def __init__(self):
	     	#set the defaults
		self.slaves=10
		self.rootversion=""
		self.rootvnum=0
		self.rootpath=""
		self.authenticationMethod=-1  #-1 for default noauth since 400-06 or UsrPwd in earlier versions
		self.time=12
		self.mol=0
		self.filelist=[]
		self.globussupport=0
		
		self.CF=[]
		self.localfilelist=[]
		self.externalfilelists=[]
		
		self.liblist=[]
		self.tree=""
		self.package=""
		self.user=""
		self.masterslave="master"
		self.rootrcdefault=1
		self.analysisscript=""
		self.proofenv=[]
		self.configfile=""
		self.debugLevel=0
		self.jobsubmissions=0
		
		#overwrite the defaults with user parameters (if given)
		self.getParameters()
		self.getHome()
		self.getUser()
		self.getProofenv()  #read parameters in proof_env.conf
				
		try:
			os.mkdir(os.environ["HOME"]+"/proof_temp")  #if possible, use the proof-dir
		except exceptions.OSError:
			print "Could not create directory $HOME/proof_temp ."
			pass
		
		print PROOFPATH
		
		print "ROOT files"
		print self.filelist	
		
		self.job=CJob(self.slaves,self.user,self.masterslave,self.mol,self.proofenv,self.rootversion,self.rootvnum,self.home)
		self.job.getCapabilitys()  
		
		if self.liblist != []:	#must be done before CROOT object is declared because the package is needed in the ROOT session
			print "building package"
			self.buildPackage()		
		
		self.root=CRootSession(self.home,self.package,self.filelist,self.tree,self.rootversion,self.analysisscript,self.liblist)
		print "after ROOT init"
		
		self.rootvnum,self.rootpath=self.root.rootlogin()
		
		os.environ['rootversion']=self.rootversion
		os.environ['rootvnum']=self.rootvnum
		os.environ['authentication']=str(self.authenticationMethod)
		print "rootvnum : "+self.rootvnum
		print "ROOT path : "+self.rootpath

		#check the authentication methods
		self.authentication=CAuthentication(self.authenticationMethod,self.user,self.home)

#		self.job=CJob(self.slaves,self.user,self.masterslave,self.mol,self.proofenv)
		
	def work(self):
		if self.configfile != "":
			self.getConfigfile()
		
		self.authentication.work()
		print "after authentication"
				
		#also check the libraries and analysis scripts
		print "for check"
		print self.liblist
		print self.analysisscript
		if self.liblist != []: # or self.analysisscript !="":
			print "checking files"
			self.checkFiles() #this checks only the librarys and the analysis file for existance

		self.checkForremote()
		print "Local ROOT files"
		print self.localfilelist
		if self.localfilelist != []:
			self.CF=self.root.checkRootfiles(self.localfilelist,self.user,self.proofenv[0][1])
		
		print "External files : "
		print self.externalfilelists
		
		if REMOTE == 1:
			self.callRemote()
		
		self.jobsubmissions=self.job.work()
		print "Count of submissions : "
		print self.jobsubmissions
			
#########	self.buildRootrc()
		
		self.buildProofconf()
		print "after buildproofconf"
		self.buildRootauthrc()
		print "after building rootauthrc"
		self.root.work()

		newsession=""
		while newsession != "q" or newsession != "s":
			newsession=raw_input("Do you want to (q)uit PROOF or (s)tart another ROOT session? ")
			if newsession == "q":
				break
			elif newsession == "s":
				newsession=""
				self.root.work()

		self.updateProofhistory()
		self.cleanup()
		
			
	def getParameters(self):
		try:
        		opts, args = getopt.getopt(sys.argv[1:],"h?s:v:a:mf:t:c:rgl:n:d:o:p:",["help","slaves=","rootversion=","authentication=","mol","gui","file=","tree=","configfile=","rootrc=","library=","analysisscript=","debug=","GLOBUS=","PROOFPATH="])
		except getopt.GetoptError:
			print "Unknown parameter found. Aborting session. Please type prooflogin -h for help."
        		sys.exit(1)
    		
		for o, a in opts:
			if o in ("-o", "--GLOBUS"):
				print a
				if a == "1":
					self.globussupport=str(a)
				else : print "This ROOT version does not support GLOBUS"
				
		for o, a in opts:
			if o in ("-g", "--gui"):
				import gui
				mygui=gui.CGui(self.globussupport)
				mygui.master.title("PROOF - The Parallel ROOT Facility") 
				#mygui.info()
				self.slaves,self.filelist,self.liblist,self.analysisscript,self.authenticationMethod,self.debugLevel,self.mol,self.tree=mygui.mainfunc()
				mygui.master.destroy()
				del mygui
			
		for o, a in opts:
        		print o
			if o in ("-?", "-h", "--help"):
			 	self.printOutput(o)
        			sys.exit(0)
	      		elif o in ("-s", "--slaves"):
				print a  # a is a string object
				if 1 < int(a) < 16:	 #and a >= 4: #usr strcmp instead of  < or > , or use atoi(a)
					self.slaves=int(a)
				else:
					self.printOutput(o)
        		elif o in ("-v", "--rootversion"):
				self.rootversion=a 
			elif o in ("-a", "--authentication"):
				if int(a) == 0 :
					if int(a) == 3 and self.globussupport == 1:
						self.authenticationMethod=int(a)
					else : self.authenticationMethod=0
				else:
					self.printOutput(o)
			elif o in ("-m", "--mol"):
				self.mol=1
			elif o in ("-f", "--file"):
				self.filelist=a.split(",")
			elif o in ("-c", "--configfile"):
				self.configfile=a
			elif o in ("-l", "--library"):
				self.liblist=a.split(",")
			elif o in ("-n", "--analysisscript"):
				self.analysisscript=a		
			elif o in ("-t", "--tree"):
				self.tree=a	
			elif o in ("-r", "--rootrc"):
				self.rootrcdefault=0 #use user specified .rootrc
			elif o in ("-d","--debug"):
				if int(a) >= 0 and int(a) <= 2:
					self.debugLevel=int(a)	
				
	def printOutput(self,parameters): #parameters is a list
		for parameter in parameters:
			if parameter in ("?", "h", "help"):
	 			print "Welcome to the startup-script of PROOF. Use with :"
				print "submit.sh [-s] slave-count [-t] termination-time in hours [-f] file1,file2,... [-l] filelist [-m] [-v] root-version [-a] authentication"
				print "-s	slave-count"
				print "This is the number of slaves you want to use (5-15)."
				print "-f	filename"
				print "This is one (of the) file(s) you wish to analyse. \nroot://lxb050.gsi.de//users/analysefile.root  or /users/analysefile.root "
				print "-t	treename \n"
				print "This is the name of the tree that you want to analyse. \nIf you use the -f option you have to use also the -tree option."
				print "-l	librarys"
				print "This is one (of the) library(s) you want to use. \n //users/analyselib.so "
				print "-n	analysis script"
				print "This is the analysis script you want to use. \n //users/analyse.C "
				print "-c	configfile"
				print "This is a file in which you have written the parameters of your analyse.\nThis is usefull if you often uses the same parameters."
				print "-m	master on localhost"
				print "This option starts the PROOF-master-server on your local machine, \nso you can have one more slave."
				print "-v	root-version \n"
				print "This is the desired ROOT-version with which you like to work. \nIt looks like dev or old or 400-04,etc."
				print "-a	authentification-method"	
				print "This can be (at this time) -1 for no authentication (only in ROOT version 400-06 and later), 0 for USRPWD  or 3 for GLOBUS."
				print "-d	debug level \n"
				print "This can be :\n0 (standard),\n1 for extended function output and error messages and also the config files will not be deleted afterwards"
				print "and 2 where you additionally have to execute every function by entering n and RETURN."
				print "ATTENTION : Please remind that you have to delete all config files manually afterwards."
				print 
				print "All files that are builded by this script will be deleted afterwards automatically."
				print "This script was tested on the following ROOT Versions: \nROOT 310-02, 400-03, 400-04, 400-06, 400-08, 401-02"
			if parameter in ("s"):
				print "Only between 5 and 15 slaves. Set to default of 10 slaves."
			if parameter in ("v"):
				print "ROOT-Version is set to the default version pro."
			if parameter in ("a"):
				print "Authentication method is set to the default UsrPwd."


	def getProofenv(self): #error for incorrect files : "proof_env.conf is invalid!"
		try:
			print PROOFPATH
			f=open(PROOFPATH+"/proof_env.conf")
		except IOError, (errno, strerror):
			print "proof_env.conf  not found! This file must be placed in your PROOF directory to execute PROOF!"
			sys.exit(1)
		else:	
			ll=[]
			text=f.readlines()
			for line in text:
				l=[]
				if line.find("#") == -1:
					words=line.split()
					for word in words:
						l.append(word)
				if len(l) > 0:
					ll.append(l)
			f.close()
			if len(ll) == 0:
				print "No ressources defined in proof_env.conf!"
				sys.exit(1)
			else:
				self.proofenv=ll
		
#This is the debug function, this should be standing at the end of every function  #Test, if it's not better to implement a global function which is called instead		
		if self.debugLevel > 0:
			print "\n\nCProofSession::getProofenv()\n"
			for lines in self.proofenv:
				print lines
			if self.debugLevel > 1:
				while raw_input("Enter n to proceed to next function.") != "n":
					pass
		
	def checkForremote(self):
		#check proofenv, to get the current facility and to check, if there are any other facilitys, if not copy all filelist to localfilelist
		if len(self.proofenv) < 2:
			print "No remote facilitys available!"
			REMOTE=0
			self.localfilelist=self.filelist
			return
		
		#check filelist, if there are any files outside the current facility 
		#split filelist entrys into location, hostname and filename
		for files in self.filelist:
			line=files.split(':')
			if len(line) > 1:
				for lines in self.proofenv:
					if line[0] == lines[0] and lines[0] != self.proofenv[0][0]:	 #file loc=facility and is not the current facility
						REMOTE=1
						remotefacility=lines[0]
	
		#build a list with needed CRPS's
		#this is not needed at this time because, there is only one remote facility
					
		#check, if files are located in proofenv facilitys
		#for files outside the proof facilitys, raise an error and exit
	
		#create filelists for the sessions
		print "Checking for remote"
		print self.filelist
		for file in self.filelist:
			line=file.split(':')
			print "checking for remote"
			if len(line) > 1 and line[0] != self.proofenv[0][0]:  #filtering local files out of list  #OK
				for each in self.proofenv:
					if line[0] == each[0]:  #if file loc == facility
						found=0
						for every in self.externalfilelists:
							ever=every[0].split(':')
							if line[0] == ever[0]:
								print "New external file added"
								every.append(file)  #filelist wird um eins erweitert und wieder processed
								found = 1
								break
						if found == 0:
							externalfiles=[]
							externalfiles.append(file)  #was .append(line) before
							self.externalfilelists.append(externalfiles)
							print "New external filelist created"
				#get local files in tmp folders
				
			else :
				print "New local file added"
				self.localfilelist.append(file)  #was .append(line) before
			
#This is the debug function, this should be standing at the end of every function 		
		if self.debugLevel > 0:
			print "\n\nCProofSession::checkForremote()\n"
			if self.debugLevel > 1:
				while raw_input("Enter n to proceed to next function.") != "n":
					pass
						
	def callRemote(self):
		print "Starting remote"
		#start rootd on local frontend host
		os.system("ssh -i "+self.home+"/.ssh/PROOF "+self.proofenv[0][1]+" "+PROOFPATH+"/rootd.sh")
		#start globus authentication
		
		#pack parameters for CRPS('s)
		pid=os.getpid()

		#start CPRS(')
		i=0
		#for each in remotesessions:   #don't execute prooflogin.py, execute  proof
		os.spawnl(os.P_NOWAIT,"globus-job-run "+self.proofenv[1][1]+" proof --REMOTE --PID "+pid+" -f "+self.externalfilelists[i]+" -s "+self.remoteslave+" -a 3")
		#os.spawnl(os.P_NOWAIT,"globus-job-run "+self.proofenv[1][1]+" "+PROOFPATH+"/prooflogin.py --REMOTE --PID "+pid+" -f "+self.externalfilelists[i]+" -s "+self.remoteslave+" -a 3")
		i+=1
	
		
	def getRootVersion(self): 
		pass
		#if self.rootdefault == 0:
			#self.rootversion=raw_input("This ROOT version is not available! Please choose an installed version.")
			#self.rootvnum=commands.getoutput("root-config --version | sed -e 's/\.//g' | sed -e 's/\///g'")   #returns something like  40008
		
	def getHome(self):
		self.home=commands.getoutput("/bin/echo $HOME")

	def getUser(self):
		self.user=commands.getoutput("/usr/bin/whoami")

	def checkFiles(self):
		for each in self.liblist:
			if commands.getstatusoutput("df "+each)[0] != 0:
				print "File "+each+" not found!"
				sys.exit(1)
		if commands.getstatusoutput("df "+self.analysisscript)[0] != 0:
				print "File "+self.analysisscript+" not found!"
				sys.exit(1)
				
#This is the debug function, this should be standing at the end of every function 		
		if self.debugLevel > 0:
			print "\n\nCProofSession::checkFiles()\n"
			if self.debugLevel > 1:
				while raw_input("Enter n to proceed to next function.") != "n":
					pass
			
	def getConfigfile(self):
		try:
			f=open(self.configfile)
		except:
			print "Config file "+self.configfile+" does not exists!"
			sys.exit(1)
			
		for line in f.readlines():
			if line.split()[0] == "-s" or line.split()[0] == "-slaves":
				if 5 < int(line.split()[1]) < 16:	 #and a >= 4: #usr strcmp instead of  < or > , or use atoi(a)
					self.slaves=int(line.split()[1])
				else :
					self.slaves=10
			elif line.split()[0] == "-a" or line.split()[0] == "-authentication":
				if int(line.split()[1]) == 0 or int(line.split()[1]) == 3:
					self.authenticationMethod=int(a)
				else:
					printOutput(o)
			elif line.split()[0] == "-m" or line.split()[0] == "-mol":
				self.mol=1
			elif line.split()[0] == "-n" or line.split()[0] == "-analysisscript":
				self.analysisscript=line.split()[1]
			elif line.split()[0] == "-f" or line.split()[0] == "-file":
				self.filelist.append(line.split()[1])
			elif line.split()[0] == "-l" or line.split()[0] == "-library":
				self.liblist.append(line.split()[1])
			elif line.split()[0] == "-t" or line.split()[0] == "-tree":
				self.tree=line.split()[1]
			elif line.split()[0] == "-r" or line.split()[0] == "-rootrc":
				self.rootrcdefault=0
			#elif line.split()[0] == "-g":  #GUI per config file ???

#This is the debug function, this should be standing at the end of every function 		
		if self.debugLevel > 0:
			print "\n\nCProofSession::getConfigfile()\n"
			if self.debugLevel > 1:
				while raw_input("Enter n to proceed to next function.") != "n":
					pass


#this cannot be part of CProofSession, because of the LSF and PBS specific commands and the PROOF queue, must be part of CJobLsf
#in an enviroment, there the slavecount and slavespread over GSI and FZK depends on the files to analyse, this function is not 
#necessary, because of the slavecount at GSI can depend on the free PROOF resources at GSI 
#(sometimes it's better to wait for new slaves, sometimes it might be better to start the session immediately)
	def getFreeproofresources(self):
		jobs=commands.getoutput(path+"/bjobs -J proofd -q proof |  wc -l")
		myjobs=commands.getoutput(path+"/bjobs -u self.user -J proofd -q proof | wc -l")
		
		if jobs >= 30:
			print "Sorry, no free PROOF jobslots at this time. Please try again later."
			wait = raw_input("Should the script waiting until there are enough free jobslots?:")
			if wait == "y" or "Y":
				while 1:
					time.sleep(60)
					jobs=commands.getoutput(path+"/bjobs -J proofd -q proof |  wc -l")
					if 30 - jobs >= self.slaves:
						break
			else:
				exit(1)
		
		if myjobs >= 11:
			print "Sorry, no more PROOF jobs for you at this time. Please finish your other jobs first."
			wait = raw_input("Should the script waiting until there are enough free jobslots?:")
			if wait == "y" or "Y":
				while 1:
					time.sleep(60)
					myjobs=commands.getoutput(path+"/bjobs -u "+self.user+" -J proofd -q proof |  wc -l")
					if myjobs <= 11:
						break
			else:
				exit(1)
		
		if 30 - jobs < self.slaves:
			freejobs=str(30-jobs)
			print "Sorry, only "+freejobs+" free PROOF jobslots are available at this time. "
			wait = raw_input("Should the script (w)ait until there are enough free jobslots, do you want to work with the (c)urrently free slaves or \n do you want to (e)xit?:")
			if wait == "w" or "W":
				while 1:
					time.sleep(60)
					jobs=commands.getoutput(path+"/bjobs -J proofd -q proof |  wc -l")
					if jobs >= self.slaves:
						break
			elif wait == "c" or "C":
				pass
			else:
				exit(1)


	def buildProofconf(self):
		ii=1
		ff = open(self.home+"/.proof.conf",'w')
		print "Creating .proof.conf"
		print ii
		print self.jobsubmissions
		time.sleep(10)
		while ii <= self.jobsubmissions:
			s=str(ii)
			try:
				print "Open proofi"+s+".conf"
				f=open(self.home+"/proof_temp/proofi"+s+".conf")
			except IOError, (errno, strerror):
				print "File proofi"+s+".conf not found"
				pass
			else:		
				ff.write(f.readline())
				print f.readline()
				print "Writing data from proofi"+s+".conf to .proof.conf"
				f.close()
				print os.system("/bin/rm "+self.home+"/proof_temp/proofi"+s+".conf")
			ii+=1
		ff.close()


#this can be part of the new class CAuthentication

#	def buildRootrc(self):
#		try:
#			os.system("/bin/cp "+self.home+"/.rootrc "+self.home+"/rootrc")
#			print "Your .rootrc has been copied to rootrc and will be restored after the session has ended."
#		except IOError:
#			os.system("/bin/cp "+self.rootpath+"/config/rootrc.in "+self.home+"/.rootrc")
#			print "No .rootrc found in your $HOME directory. The script will use the standard .rootrc, which will be 
#deleted afterwards."
#		if self.rootrcdefault == 1:
#			os.system("/bin/cp "+self.rootpath+"/config/rootrc.in "+self.home+"/.rootrc")
#		
#		f=open(self.home+"/.rootrc",'r+')  #proof against set values first
#		if self.authenticationMethod == 0:
#			f.write("Rootd.Authentication: 0"+ '\n')
#			f.write("Proofd.Authentication: 0"+ '\n')
#			f.write("UsrPwd.Login: "+self.user+ '\n')
#			f.write("UsrPwd.LoginPrompt: 0"+ '\n')
#			f.write("UsrPwd.ReUse: 0"+ '\n')
#		elif self.authenticationMethod == 3:
#			f.write("Rootd.Authentication: 3"+ '\n')				
#			f.write("proofd.Authentication: 3"+ '\n')
#			f.write("Globus.Login: cd:~/.globus cf:usercert.pem  kf:userkey.pem  ad:/etc/grid-security/certificates"+'\n')	#use user paths instead			
#			f.write("Globus.LoginPrompt: 0"+ '\n')	
#			f.write("Globus.ReUse: 1"+ '\n')
#		f.close()
#	f=open(self.home+"rootrc",'r')
#	for line in f.readlines():
#		if self.authenticationMethod == 0:
#			if line.find('#') == -1 and line.find("Proofd.Authentication") != -1 and line.find("0") != -1:
#				f.seek(0,0)
#				f.write("Rootd.Authentication: 0"+ '\n')
#			elif line.find('#') == -1 and line.find("Proofd.Authentication") != -1 and line.find("0") != -1:
#				linef.seek(0,0)
#				f.write("Proofd.Authentication: 0"+ '\n')
				
	def buildRootrc(self):
		try:
			os.system("/bin/cp "+self.home+"/.rootrc "+self.home+"/rootrc.user")
			print "Your .rootrc has been copied to rootrc.user and will be restored after the session has ended."
		except IOError:  #IOError is for file::open()
			os.system("/bin/cp "+self.rootpath+"/config/rootrc.in "+self.home+"/rootrc")
			print "No .rootrc found in your $HOME directory. The script will use the standard .rootrc, which will be deleted afterwards."
		if self.rootrcdefault == 1:
			os.system("/bin/cp "+self.rootpath+"/config/rootrc.in "+self.home+"/rootrc.in")
		
		#read the data
		if self.rootrcdefault == 1:
			f=open(self.home+"/rootrc.in",'r')  #read from rootrc  or from  rootrc.in
			text=open(self.home+"/rootrc.in").readlines()
		else :
			f=open(self.home+"/rootrc.user",'r')  #read from rootrc  or from  rootrc.in
			text=open(self.home+"/rootrc.user").readlines()
		f.close()
		#delete previous settings
		linecount=0
		for line in text:
			if line.find('#') == -1 and line.find("Rootd.Authentication") != -1:
				text[linecount]="\n"
			elif line.find('#') == -1 and line.find("Proofd.Authentication") != -1:
				text[linecount]="\n"
			elif line.find('#') == -1 and line.find("UsrPwd.Login") != -1:
				text[linecount]="\n"
			elif line.find('#') == -1 and line.find("UsrPwd.LoginPrompt") != -1:
				text[linecount]="\n"
			elif line.find('#') == -1 and line.find("UsrPwd.ReUse") != -1:
				text[linecount]="\n"
			elif line.find("#") == -1 and line.find("Globus.Login") != -1:
				text[linecount]="\n"
			elif line.find("#") == -1 and line.find("Globus.LoginPrompt") != -1:
				text[linecount]="\n"
			elif line.find("#") == -1 and line.find("Globus.ReUse") != -1:
				text[linecount]="\n"
			linecount+=1
		
		if self.authenticationMethod == 0:
			textb="Rootd.Authentication: 0\nProofd.Authentication: 0\nUsrPwd.Login: "+self.user+"\nUsrPwd.LoginPrompt:0\nUsrPwd.ReUse: 1\n"
		elif self.authenticationMethod == 3:		#anpassen der globus-pfade
			textb="Rootd.dAuthentication: 3\nProofd.Authentication: 3\nGlobus.Login: cd:~/.globus cf:usercert.pem kf:userkey.pem  ad:/usr/local/globus2.0/share/certificates\nGlobus.LoginPrompt: 0\nGlobus.ReUse: 1\n"	

		#write the data
		ff=open(self.home+"/.rootrc",'w')  #write to .rootrc
		#textb+=text
		ff.writelines(textb)
		ff.close()
		ff=open(self.home+"/.rootrc",'a')  #write to .rootrc
		ff.writelines(text)
		ff.close()


	def buildRootauthrc(self): 
		try:
			f=open(self.home+"/.proof.conf",'r')				
		except IOError:  #IOError is for file::open()
			print "No .proof.conf found in your $HOME directory. Possibly PROOF is not able to write to your HOME directory."
			proofSession.cleanup()			
			sys.exit(1)
		line=f.readline()
		words=line.split()
		string=words[1]
		
		if self.rootvnum >= 40006:
			if self.authenticationMethod == 0:
				string+=" user "+self.user+" method 0 ru:1 pt:0"
			elif self.authenticationMethod == 3:
				string+=" user "+self.user+" method 3 ru:1 pt:0 ad:/usr/local/globus2.0/share/certificates"
		
		string+=" proofserv "
		#set the filedescriptor back to the top of the file		
		f.seek(0, 0) 
		
		for lines in f.readlines():
			words=lines.split()
			string+=words[1]
			string+=":"
			string+=self.user
			string+=":"
			string+=str(self.authenticationMethod)
			string+=" "
		
		f.close()
		
		ff=open(self.home+"/.rootauthrc",'w')
		ff.write(string)
	
	
	def buildPackage(self):
		try:
			os.removedirs(self.home+"/proof_temp/"+self.user+"_libpar")
		except:
			pass
		try:
			os.remove(self.home+"/proof_temp/"+self.user+"_libpar.par")
		except:
			pass
		try:	#instead of this remove the whole dir and package
			print self.home+"/proof_temp/"+self.user+"_libpar/PROOF-INF"
			os.makedirs(self.home+"/proof_temp/"+self.user+"_libpar/PROOF-INF")
		except:
			print "Can't build directory for package. Possibly PROOF can't write to your HOME directory."
			#proofSession.cleanup()			
			sys.exit(1)
		os.chdir(self.home+"/proof_temp/"+self.user+"_libpar/PROOF-INF")
		f=open("SETUP.C",'w')
		f.write("Int_t SETUP()\n{\n")
		f.write("gROOT->LoadClass(\"TGX11\",\"GX11\");\n")
		for line in self.liblist:
			f.write("gSystem->Load(\""+line+"\");\n")
		f.write("return 1;\n}")
		f.close()
		os.chdir("../..")
		os.system("tar -czf "+self.user+"_libpar.par "+self.user+"_libpar")
		#os.system("mv "+self.user+"_libpar.par "+self.home+"/proof/"+self.user+"_libpar.par")	
		os.system("rm -r "+self.user+"_libpar")	
		self.package=self.user+"_libpar.par"


	def updateProofhistory(self):
		try:
			f=open(self.home+"/.proof_history",'r')
		except IOError:
			f=open(self.home+"/.proof_history",'w')
		filelist1=[]
		liblist1=[]
		analysislist1=[]
		history2=[]
		history=f.readlines()
		f.close()
		for lines in history:
			history2.append(lines.rstrip("\n"))
		#copy entrys to the different lists
		for each in history2:
			if (each.find("-f") != -1):
				filelist1.append(each)
			elif (each.find("-l") != -1):
				liblist1.append(each)
			elif (each.find("-n") != -1):
				analysislist1.append(each)
		#remove double entrys from lists	
		for every in self.filelist:
			for each in filelist1:
				if each == "-f "+every:
					print "file entry removed"
					filelist1.remove(each)
		for every in self.liblist:
			for each in liblist1:
				if each == "-l "+every:
					print "lib entry removed"
					liblist1.remove(each)
		for each in analysislist1:
			if each == "-n "+self.analysisscript:
				print "ana entry removed"
				analysislist1.remove(each)
		#remove overheading entrys
		while len(filelist1) > 1000:
			filelist1.pop(0)
		while len(liblist1) > 50:
			liblist1.pop(0)	
		while len(analysislist1) > 50:
			analysislist1.pop(0)	
		#write lists to file
		f=open(self.home+"/.proof_history",'w')
		for each in filelist1:
			f.write(each+"\n")
		for each in self.filelist:
			f.write("-f "+each+"\n")
		for each in liblist1:
			f.write(each+"\n")
		for each in self.liblist:
			f.write("-l "+each+"\n")
		for each in analysislist1:
			f.write(each+"\n")
		f.write("-n "+self.analysisscript+"\n")		
		f.close()
		print "back to CPS"


	def cleanup(self):
		self.job.jobKill()
		for each in self.CF:
			each.output()
		for each in self.CF:
			if each.rootd == 1:
				print "Killing ROOT demon on host "+each.location
				os.system("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" pkill -U "+self.user+" rootd")
		if REMOTE == 1:
			os.system("ssh -i "+self.home+"/.ssh/PROOF "+self.proofenv[0][1]+" pkill -U "+self.user+" rootd")
			print "Frontend ROOT demon killed."
		
		if self.debugLevel == 0: 
			os.system("rm -f "+self.home+"/.proof.conf") 
			os.system("rm -f "+self.home+"/.rootauthrc") 
			#os.remove(self.home+"/.rootrc")
			#os.remove(self.home+"/rootrc.in")
			os.system("rm -f "+self.home+"/.ssh/PROOF")
			os.system("rm -f "+self.home+"/.ssh/PROOF.pub")
			#also try to delete the key entry in authorized keys
			#problematic: this should normaly be the last entry, but only if the user don't enter a new one
			try:
				os.rename(self.home+"/rootrc.user ",self.home+"/.rootrc")
			except:
				pass
			os.system("rm -f "+self.home+"/proof_temp/proofstarter.C") 
			os.system("rm -f "+self.home+"/proof_temp/"+self.user+"_libpar.par")
		
			os.system("rm -rf "+self.home+"/proof_temp")
			os.system("rm -rf "+self.home+"/proof")  
		

class CRemoteProofSession:
	def __init__(self): 
	     	#set the defaults
		self.slaves=0
		self.rootversion="pro"
		self.rootvnum=0
		self.rootpath=""
		self.rootdefault=1
		self.globussupport=0
		self.authenticationMethod=3
		self.time=12
		self.mol=0
		self.treename=""
		self.CF=[]
		self.localfilelist=[]
		self.user=""
		self.proofenv=[]
		self.PID=0
		
		self.jobsubmissions=0
		
		#overwrite the defaults with user parameters (if given)
		self.getParameters()
		self.getHome()
		self.getUser()
		self.getProofenv()
		
		try:
			os.mkdir(os.environ["HOME"]+"/proof_temp")
		except exceptions.OSError:
			pass
		
		self.root=CRootSession(self.home,"",self.localfilelist,self.treename,"",self.rootversion,"")

		#this class will start the tcprouter if needed
		
		#this can be called for testing the root files, so this function has to be redeveloped
		
		if self.localfilelist != []:
			self.root.checkRootfiles(self.localfilelist,self.rootdefault,self.proofenv[0][1])
			print "after ROOT check files"
		
		#self.rootvnum,self.rootpath=self.root.rootlogin()
		#os.environ['rootvnum']=self.rootvnum
		#print "rootvnum : "+self.rootvnum
		#print "ROOT path : "+self.rootpath
		
		#this can be called for testing the globus dependend files, so this function has to be redeveloped
		self.authentication=CAuthentication(self.authenticationMethod,self.user,self.home)
		
		self.job=CJob(self.slaves,self.user,"slave",0,self.proofenv,self.rootversion,self.rootvnum,self.home)

		#self.TcpRouter(self.slaves) #creating a TCPRouter object with pair of sockets for every rootd and proofd
		
	def work(self):
		self.authentication.work()
		print "after authentication"
		#self.getRootVersion()
		
		self.jobsubmissions=self.job.work()
		print "count of submissions:"
		print self.jobsubmissions
		
		#self.getRootVersion()
		self.buildProofconf()
		print "after buildproofconf"
  		
		#start TCPRouter
		#self.TcpRouter.work()
		
		#os.system("globus-url-copy file://$HOME .proof.conf gsiftp:///$HOME/.proof.conf")
		
		#self.cleanup()
		
			
	def getParameters(self):
		try:
        		opts, args = getopt.getopt(sys.argv[1:], "s:v:a:f:t:xyp:o:",["REMOTE","PATH","PID","GLOBUS"])
		except getopt.GetoptError:
			print "Unknown parameter in remote session. Aborting session. in CRPS"
			sys.exit(2)
		print opts
		print args
		for o, a in opts:
			if o in ("-o", "--GLOBUS"):
				print a
				if a == "1":
					self.globussupport=str(a)
				else : print "This ROOT version does not support GLOBUS"
		for o, a in opts:
			if o in ("-s","--slaves"):
				self.slaves=int(a)
	       		elif o in ("-v","--rootversion"):
				self.rootversion=a 
			elif o in ("-a","authenticationmethod"):  #not needed but with respect to kerberos,etc.
				self.authenticationMethod=int(a)
			elif o in ("-f","--file"):
				self.localfilelist.append(a)
			elif o in ("-t","--tree"):
				self.treename=a	
			elif o in ("-x",""):
				self.PID=a

	def getRootVersion(self): 
		pass
		#if self.rootdefault == 0:
			#self.rootversion=raw_input("This ROOT version is not available! Please choose an installed version.")
			#self.rootvnum=commands.getoutput("root-config --version | sed -e 's/\.//g' | sed -e 's/\///g'")   #returns something like  40008
		
	def getHome(self):
		self.home=commands.getoutput("/bin/echo $HOME")
		print self.home

	def getUser(self):
		self.user=commands.getoutput("/usr/bin/whoami")
		print self.user

	def getProofenv(self): #error for incorrect files : "proof_env.conf is invalid!"
		try:
			f=open(PROOFPATH+"/proof_env.conf")
		except IOError, (errno, strerror):
			print "proof_env.conf  not found! This file must be placed in "+PROOFPATH+" proof to execute PROOF!"
			sys.exit(1)
		else:	
			ll=[]
			text=f.readlines()
			for line in text:
				l=[]
				if line.find("#") == -1:
					words=line.split()
					for word in words:
						l.append(word)
				if len(l) > 0:
					ll.append(l)
			f.close()
			if len(ll) == 0:
				print "No ressources defined in proof_env.conf!"
				sys.exit(1)
			else:
				self.proofenv=ll

	def buildProofconf(self):  #this is only the remote .proof.conf and has to be copied to the calling environment/facility
		ii=1
		ff = open(self.home+"/.proof.conf",'w')
		print "writing .proof.conf"
		print ii
		print self.jobsubmissions
		while ii <= self.jobsubmissions:
			print "submission"
			s=str(ii)
			print "s="
			print s
			try:
				print "open proofi.conf"
				f=open(self.home+"/proof_temp/proofi"+s+".conf")
			except IOError, (errno, strerror):
				print "proofi"+s+".conf not found"
				pass
			else:		
				ff.write(f.readline())
				print f.readline()
				print "writing to .proof.conf"
				f.close()
				print os.system("/bin/rm "+self.home+"/proof_temp/proofi"+s+".conf")
			ii+=1
		ff.close()
		try:
			commands.getoutput("globus-url-copy file://"+self.home+"/remote_proof.conf gsiftp://"+self.home+"/remote_proof.conf")
			  #must using the home of the calling environment in the second part
		except:
			pass #warning : no remote ressources available  #kill jobs (if there are any)

	def cleanup(self):    #get the cleanup func. from CProofSession
		self.job.jobKill()
		
		#only needed if the master is started by a CRPS
		#if self.mol == 1:
		os.system("rm -f "+self.home+"/.proof.conf")
				
		print "before killing rootd"
		for each in self.CF:
			print "each and everything"
			if each.rootd == 1:
				print "killing "+each.location
				os.system("ssh -i "+self.home+"/.ssh/PROOF "+each.location+" pkill -U "+self.user+" rootd")
		os.system("ssh -i "+self.home+"/.ssh/PROOF "+self.proofenv[0][1]+" pkill -U "+self.user+" rootd")
		print "after killing rootd"

class TcpRouter:
	def __init__(self,sockets):
		self.sockets=sockets	
		#socket[sockets] = class CSocket()
		socketcount=0
		#read proof.conf for socket parameter 
		#f=open(self.home+"/.proof.conf")
		#read data and create new socket		
		#for lines in f.readlines():
		#	line=lines.split()
		#	socket[socketcount]=CSocket(line[1],line[2])
		#	socketcount+=1
		#f.close()
		#read data of CF objects or create somethere before a list with rootd objects
	
	def work(self):
		pass
		#create a socket/thread for every slave and rootd
		#for each in .proof.conf
		#	thread.start_new_thread(masterToSlave.receiveAndSend,(slaveToMaster,)) 
		#for each in CF:
		#	if each.rootd == 1:
		#		thread.start_new_thread(masterToSlave.receiveAndSend,(slaveToMaster,))
			
	
class CSocket:
	def __init__(self,host,port):
		self.buffersize=1
		self.host=host
		self.port=port
		self.server
		self.client
	
	def work(self):
		#start 2 threats
		self.server=thread.start_new_thread(self.serverCommunication,(slaveToMaster,))  #instead od clnt
		self.client=thread.start_new_thread(self.clientCommunication,(masterToSlave,)) 
		#kill the threads
		
	def serverCommunication(self):
		while 1:
			buf = self.clnt.recv(self.buffersize)
			other.sock.send(buf)
		self.sock.close()
	
	def clientCommunication(self):
		while 1:
			buf = self.sock.recv(self.buffersize)
			other.clnt.send(buf)			
		self.sock.close()
	
	
	
#delete this line
#proofSession=CProofSession() #Parameterliste uebergeben
global proofSession
#global REMOTE

def main():
	#this is the only method to define variables in a function which are declared outside this function
	#global REMOTE
	#REMOTE=0
	#global PROOFPATH
	#PROOFPATH="/usr/local/grid/PROOF"
	
	try:
	       	opts, args = getopt.getopt(sys.argv[1:], "h?s:v:a:mf:t:c:rgl:n:d:xyo:p:", ["help","slaves=","rootversion=","authentication=","mol","file=","tree=","configfile=","rootrc","gui","library=","analysis=","debug=","REMOTE","PID","GLOBUS=","PATH="])
	except getopt.GetoptError:
		print "Unknown parameter. Aborting session. Please type prooflogin -h for help. In main()"
        	sys.exit(1)

    	for o, a in opts:
        	if o in ("-p","--PATH"):   #there have to be several other parameters like the calling facility, etc.
		 	global PROOFPATH
			global CERTIFICATEPATH
			global GRIDMAPPATH
			PROOFPATH,GRIDMAPPATH,CERTIFICATEPATH=a.split(",")
		if o in ("-y","--REMOTE"):   #there have to be several other parameters like the calling facility, etc.
		 	print "REMOTE"
        		global REMOTE
			REMOTE=1
		if o in ("-x","--PID"):   #there have to be several other parameters like the calling facility, etc.
		 	print PID
		
	#global proofSession

	if REMOTE==1:
		print "CRPS"			
		proofSession=CRemoteProofSession()
	else :
		print "CPS"
		proofSession=CProofSession()
	
	def handler(signum, frame):
		print "Got signal "+str(signum)+" . System will close the current PROOF session."
		proofSession.cleanup()
		sys.exit(1)
	
	signal.signal(1, handler);signal.signal(2, handler);signal.signal(3, handler);signal.signal(4, handler);signal.signal(5, handler)
	signal.signal(6, handler);signal.signal(7, handler);signal.signal(8, handler);signal.signal(9, handler);signal.signal(10, handler)
	signal.signal(11, handler);signal.signal(12, handler);signal.signal(13, handler);signal.signal(14, handler);signal.signal(15, handler)
	
	
	#proofSession=CProofSession() #Parameterliste uebergeben
	try:
		try:
			try:
				proofSession.work()
			except:
				print "ERROR"
				proofSession.cleanup()
		except KeyboardInterrupt:
			print "got an CTRL-C"    #not needed, this is signal 2
			proofSession.cleanup()
	except SystemExit:	
		print "got an exit"
		proofSession.cleanup()
	
	
main()

